﻿// c# program to create font7x10.h from font7x10.txt
// compile as console application and execute from command line with: Create7x10font >font7x10.h

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace Create7x10font
{
    class Program
    {
        static void rowToHex(string s)
        {
            int b = 0;
            int mask = 0x80;
            for (int i = 0; i < 7; i++)
            {
                if (s.Substring(i, 1) == "#")
                    b |= mask;
                mask >>= 1;
            }
            Console.Write("0x");
            Console.Write(b.ToString("X2"));
        }

        static void Main(string[] args)
        {
            StreamReader sr = new StreamReader("font7x10.txt");
            string fileContents = sr.ReadToEnd();
            sr.Close();
            char[] separator = { '\n' };
            string[] lines = fileContents.Split(separator);
            Console.Write("// standard ASCII 7x10 font\n\n");
            Console.Write("#include <avr/pgmspace.h>\n\n");
            Console.Write("const uint8_t font[] PROGMEM = {\n  ");
            int i = 0;
            for (int c = 32; c < 128; c++)
            {
                for (int row = 0; row < 10; row++)
                {
                    rowToHex(lines[i++]);
                    if (row != 9)
                        Console.Write(", ");
                }
                if (c != 127)
                    Console.Write(", ");
                else
                    Console.Write("  ");

                i++;

                Console.Write("// ");
                if (c == 32)
                    Console.Write("space");
                else if (c == 92)
                    Console.Write("backslash");
                else if (c == 127)
                    Console.Write("u with tail (Greek mu for microseconds");
                else
                    Console.Write((char)c);

                if (c != 127)
                    Console.Write("\n  ");
                else
                    Console.Write("\n};\n");
            }

            Console.ReadLine();
        }
    }
}
