#ifndef screens_h
#define screens_h

#include <Arduino.h>
#include <avr/pgmspace.h>

const uint16_t tenPower[] = {1, 10, 100, 1000, 10000};   

const uint8_t  s_0[] PROGMEM = "\x93Page"; // "Main Page"
const uint8_t  s_1[] PROGMEM = "RSSI:";
const uint8_t  s_2[] PROGMEM = "Tx bat:";
const uint8_t  s_3[] PROGMEM = "\x94:"; // "Model:"
const uint8_t  s_4[] PROGMEM = "Tmr1:";
const uint8_t  s_5[] PROGMEM = "Tmr2:";
const uint8_t  s_6[] PROGMEM = "\x93Menu"; // "Main Menu"
const uint8_t  s_7[] PROGMEM = "S";
const uint8_t  s_8[] PROGMEM = "R";
const uint8_t  s_9[] PROGMEM = "Mon"; // 89
const uint8_t s_10[] PROGMEM = "Select \x94"; // "Select Model"
const uint8_t s_11[] PROGMEM = "\x94 \x95"; // "Model Settings"
const uint8_t s_12[] PROGMEM = "\350Current \x94"; // "Copy Current Model"
const uint8_t s_13[] PROGMEM = "Transmitter \x95"; // "Transmitter Settings"
const uint8_t s_14[] PROGMEM = "\x98\x97 (%)"; // "Channels Monitor (%)"
const uint8_t s_15[] PROGMEM = "\x7Fs\x97"; // "us Monitor"
const uint8_t s_16[] PROGMEM = "\x98\x97 (\x7Fs)"; // "Channels Monitor (us)"
const uint8_t s_17[] PROGMEM = " \xEE\x96  "; // " Top switch  "
const uint8_t s_18[] PROGMEM = "\xE7\x96"; // "Bottom switch"
const uint8_t s_19[] PROGMEM = "Main "; // 93
const uint8_t s_20[] PROGMEM = "Model"; // 94
const uint8_t s_21[] PROGMEM = "Settings";  // 95
const uint8_t s_22[] PROGMEM = " switch"; // 96
const uint8_t s_23[] PROGMEM = " \x89itor"; // " Monitor" 97
const uint8_t s_24[] PROGMEM = "\xE9s"; // "Channels" 98
const uint8_t s_25[] PROGMEM = "\xE3s"; // " Servos" 99
const uint8_t s_26[] PROGMEM = "\xAD\xAD\xAD"; // blank 21-char row for drawing scrollable menu
const uint8_t s_27[] PROGMEM = "Duration:";
const uint8_t s_28[] PROGMEM = "\xCC\x99"; // "Normal Servos"
const uint8_t s_29[] PROGMEM = "Progressive \x99"; // "Progressive Servos"
const uint8_t s_30[] PROGMEM = "Travel Time:";
const uint8_t s_31[] PROGMEM = "s";
const uint8_t s_32[] PROGMEM = "Reed \xEA\xE4"; // "Reed Elevator Trim"
const uint8_t s_33[] PROGMEM = "All \x98 Button"; // "All Channels Button"
const uint8_t s_34[] PROGMEM = "\xE4 \xEC:";
const uint8_t s_35[] PROGMEM = "%";
const uint8_t s_36[] PROGMEM = "V";
const uint8_t s_37[] PROGMEM = "\xEB \xEC:"; // "Voltage Range:"
const uint8_t s_38[] PROGMEM = "Alarm \xEB:"; // "Alarm Voltage:"
const uint8_t s_39[] PROGMEM = " "; // dummy single character for highlighting editable fields
const uint8_t s_40[] PROGMEM = "\xAC "; // dummy 19-character editable field highlighter A8
const uint8_t s_41[] PROGMEM = "\xAA "; // dummy 5-character editable field highlighter A9
const uint8_t s_42[] PROGMEM = "\xAB\xAB"; // dummy 4-character editable field highlighter AA
const uint8_t s_43[] PROGMEM = "  "; // dummy 2-character editable field highlighter AB
const uint8_t s_44[] PROGMEM = "\xBB\xBB\xBB"; // dummy 18-character editable field highlighter AC
const uint8_t s_45[] PROGMEM = "\xBB "; // dummy 7-character editable field highlighter AD
const uint8_t s_46[] PROGMEM = "\xAB "; // dummy 3-character editable field highlighter AE
const uint8_t s_47[] PROGMEM = "L/D  R/U"; // left/down and right/up refer to the stick directions, not elevator - and still apply whether a servo is reversed or not
const uint8_t s_48[] PROGMEM = "Battery \xEB:"; // "Battery Voltage:"
const uint8_t s_49[] PROGMEM = "1:";
const uint8_t s_50[] PROGMEM = "2:";
const uint8_t s_51[] PROGMEM = "Off\xAD\xAD\xAB"; // "Off                "
const uint8_t s_52[] PROGMEM = "\345Down\xAA\xAA"; // "Manual Down        "
const uint8_t s_53[] PROGMEM = "\xE6> 10% Down"; // "Throttle > 10% Down"
const uint8_t s_54[] PROGMEM = "\xE5Up\xAD\xAE"; // "Manual Up          "
const uint8_t s_55[] PROGMEM = "\xE6> 10% Up\xAB"; // "Throttle > 10% Up  "
const uint8_t s_56[] PROGMEM = "\xE5Up Silent\xAE"; // "Manual Up Silent   "
const uint8_t s_57[] PROGMEM = ">10% Start Silent\xAB"; // ">10% Start Silent  "
const uint8_t s_58[] PROGMEM = "Since \x94 Chosen "; // "Since Model Chosen "
const uint8_t s_59[] PROGMEM = "\xAA\xAB"; // dummy 6-character editable field highlighter BB
const uint8_t s_60[] PROGMEM = "Unused\xAd\xAA"; //"Unused           "
const uint8_t s_61[] PROGMEM = "\xE7\x96\xAA"; // "Bottom switch    "
const uint8_t s_62[] PROGMEM = "\xEE\x96\xAD"; // "Top switch       "
const uint8_t s_63[] PROGMEM = "\xE6\xAA\xAA"; // "Throttle         "
const uint8_t s_64[] PROGMEM = "\xEA\xAA\xAA"; // "Elevator         "
const uint8_t s_65[] PROGMEM = "5\xED+\xDD"; // "50% *** + 50$ Ele"
const uint8_t s_66[] PROGMEM = "5\xED-\xDD"; // "50% *** - 50% Ele"
const uint8_t s_67[] PROGMEM = "6\xED+\xDE"; // "60% *** + 40% Ele"
const uint8_t s_68[] PROGMEM = "6\xED-\xDE"; // "60% *** - 40% Ele"
const uint8_t s_69[] PROGMEM = "4\xED+\xDF"; // "40% *** + 60% Ele"
const uint8_t s_70[] PROGMEM = "4\xED-\xDF"; // "40% *** - 60% Ele"
const uint8_t s_71[] PROGMEM = "7\xED+\xE0"; // "70% *** + 30% Ele"
const uint8_t s_72[] PROGMEM = "7\xED-\xE0"; // "70% *** - 30% Ele"
const uint8_t s_73[] PROGMEM = "3\xED+\xE1"; // "30% *** + 70% Ele"
const uint8_t s_74[] PROGMEM = "3\xED-\xE1"; // "30% *** - 70% Ele"
const uint8_t s_75[] PROGMEM = "\xE3 sweep\xBB"; // "Servo sweep      "
const uint8_t s_76[] PROGMEM = "Normal "; // CC
const uint8_t s_77[] PROGMEM = "Reverse"; // CD
const uint8_t s_78[] PROGMEM = "\xE8to"; // "Copy to"
const uint8_t s_79[] PROGMEM = "A1:";
const uint8_t s_80[] PROGMEM = "A2:";
const uint8_t s_81[] PROGMEM = "A2 \xEC 0=A1:"; // "A2 Range 0=A1:"
const uint8_t s_82[] PROGMEM = "\x94 Name"; // "Model Name"
const uint8_t s_83[] PROGMEM = "Timers";
const uint8_t s_84[] PROGMEM = "\xE3 Speeds"; // "Servo Speeds"
const uint8_t s_85[] PROGMEM = "\xE4 \xECs"; // "Trim Ranges"
const uint8_t s_86[] PROGMEM = "Mixer Steering Source";
const uint8_t s_87[] PROGMEM = "\xE9 Mixing"; // "Channel Mixing"
const uint8_t s_88[] PROGMEM = "\xE3 \xCD"; // "Servo Reverse"
const uint8_t s_89[] PROGMEM = "End Points";
const uint8_t s_90[] PROGMEM = "Sub \xE4"; // "Sub Trim"
const uint8_t s_91[] PROGMEM = "Telemetry";
const uint8_t s_92[] PROGMEM = "\342Ele"; // "0% Ele" DC
const uint8_t s_93[] PROGMEM = " 5\xDC"; // " 50% Ele" DD
const uint8_t s_94[] PROGMEM = " 4\xDC"; // " 40% Ele" DE
const uint8_t s_95[] PROGMEM = " 6\xDC"; // " 60% Ele" DF
const uint8_t s_96[] PROGMEM = " 3\xDC"; // " 30% Ele" E0
const uint8_t s_97[] PROGMEM = " 7\xDC"; // " 70% Ele" E1
const uint8_t s_98[] PROGMEM = "0% "; // E2
const uint8_t s_99[] PROGMEM = "Servo"; // E3
const uint8_t s_100[] PROGMEM = "Trim"; // E4
const uint8_t s_101[] PROGMEM = "Manual "; // E5
const uint8_t s_102[] PROGMEM = "Throttle "; // E6
const uint8_t s_103[] PROGMEM = "\xEFtom"; // "Bottom" E7
const uint8_t s_104[] PROGMEM = "Copy "; // E8
const uint8_t s_105[] PROGMEM = "Channel"; // E9
const uint8_t s_106[] PROGMEM = "Elevator "; // EA
const uint8_t s_107[] PROGMEM = "Voltage"; // EB
const uint8_t s_108[] PROGMEM = "Range"; // EC
const uint8_t s_109[] PROGMEM = "0% \xFF "; // ED
const uint8_t s_110[] PROGMEM = "Top"; // EE
const uint8_t s_111[] PROGMEM = "Bot"; // EF


const uint8_t * const flashString[] PROGMEM = {
    s_0,  s_1,  s_2,  s_3,  s_4,  s_5,  s_6,  s_7,  s_8,  s_9,
   s_10, s_11, s_12, s_13, s_14, s_15, s_16, s_17, s_18, s_19,
   s_20, s_21, s_22, s_23, s_24, s_25, s_26, s_27, s_28, s_29,
   s_30, s_31, s_32, s_33, s_34, s_35, s_36, s_37, s_38, s_39,
   s_40, s_41, s_42, s_43, s_44, s_45, s_46, s_47, s_48, s_49,
   s_50, s_51, s_52, s_53, s_54, s_55, s_56, s_57, s_58, s_59,
   s_60, s_61, s_62, s_63, s_64, s_65, s_66, s_67, s_68, s_69,
   s_70, s_71, s_72, s_73, s_74, s_75, s_76, s_77, s_78, s_79,
   s_80, s_81, s_82, s_83, s_84, s_85, s_86, s_87, s_88, s_89,
   s_90, s_91, s_92, s_93, s_94, s_95, s_96, s_97, s_98, s_99,
  s_100,s_101,s_102,s_103,s_104,s_105,s_106,s_107,s_108,s_109,s_110,s_111
};

const uint8_t  fix_0[] PROGMEM = {0,0120, 1,0131, 2,0112, 36,0242, 3,0123, 36,0243, 4,0065, 5,0066, 0xFF}; // fixed strings for screen 0 (Main Page).  Note use of octal to give column:row positions
const uint8_t  fix_1[] PROGMEM = {14,0000, 0xFF}; // Channels Monitor (%)
const uint8_t  fix_2[] PROGMEM = {16,0000, 0xFF}; // Channels Monitor (us)
const uint8_t  fix_3[] PROGMEM = {6,0060, 0xFF}; // Main Menu
const uint8_t  fix_4[] PROGMEM = {10,0040, 0xFF}; // Select Model
const uint8_t  fix_5[] PROGMEM = {12,0010, 0xFF}; // Copy Current Model
const uint8_t  fix_6[] PROGMEM = {11,0030, 0xFF}; // Model Settings 
const uint8_t  fix_7[] PROGMEM = {82,0050, 0xFF}; // Model Name
const uint8_t  fix_8[] PROGMEM = {83,0070, 49,0002, 27,0003, 50,0005, 27,0006, 0xFF}; // Timers
const uint8_t  fix_9[] PROGMEM = {84,0040, 28,0042, 30,0013, 31,0223, 29,0015, 30,0016, 31,0226, 0xFF}; // Servo Speeds
const uint8_t fix_10[] PROGMEM = {85,0050, 32,0012, 34,0033, 35,0213, 33,0015, 34,0036, 35,0216, 0xFF}; // Trim Ranges
const uint8_t fix_11[] PROGMEM = {86,0000, 0xFF}; // Mixer Steering Source
const uint8_t fix_12[] PROGMEM = {87,0030, 0xFF}; // Channel Mixing
const uint8_t fix_13[] PROGMEM = {88,0040, 0xFF}; // Servo Reverse
const uint8_t fix_14[] PROGMEM = {89,0000, 47,0130, 35,0161, 35,0231, 35,0162, 35,0232, 35,0163, 35,0233, 35,0164, 35,0234, 35,0165, 35,0235, 35,0166, 35,0236, 0xFF}; // End Points
const uint8_t fix_15[] PROGMEM = {90,0060, 35,0121, 35,0122, 35,0123, 35,0124, 35,0125, 35,0126, 0xFF}; // Sub Trim
const uint8_t fix_16[] PROGMEM = {91,0060, 1,0002, 3,0122, 36,0242, 81,0014, 36,0234, 38,0015, 36,0235, 79, 0001, 80, 0171, 0xFF}; // Telemetry
const uint8_t fix_17[] PROGMEM = {13,0000, 48,0002, 36,0242, 37,0014, 36,0234, 38,0015, 36,0235,0xFF}; // Transmitter Settings

const uint8_t* const fixed[] PROGMEM = {
   fix_0,  fix_1,  fix_2,  fix_3,  fix_4,  fix_5,  fix_6,  fix_7,  fix_8,  fix_9,
  fix_10, fix_11, fix_12, fix_13, fix_14, fix_15, fix_16, fix_17
};

const uint8_t  slc_0[] PROGMEM = {6,0147, 7,0225, 8,0245, 7,0226, 8,0246, 9,0067, 0xFF}; // selectable items for screen 0 (Main Page)
const uint8_t  slc_1[] PROGMEM = {15,0007, 0xFF}; // Channels Monitor (%)
const uint8_t  slc_2[] PROGMEM = {0,0007, 0xFF}; // Channels Monitor (us)
const uint8_t  slc_3[] PROGMEM = {0,0062, 10,0043, 11,0034, 12,0015, 13,0006, 0xFF}; // Main Menu
const uint8_t  slc_4[] PROGMEM = {0xFD, 0xFF}; // Select Model // Select Model - note special first entry of 0xFD invokes scrolling-type-2 choiceMode.
const uint8_t  slc_5[] PROGMEM = {0xFC, 0xFF}; // Copy Current Model - note special first entry of 0xFC invokes scrolling-type-3 choiceMode.
const uint8_t  slc_6[] PROGMEM = {0xFE, 11, 6, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91}; // Model Settings - note special first entry of 0xFE invokes scrolling-type-1 choiceMode. 2nd entry (10) is number of items
const uint8_t  slc_7[] PROGMEM = {11,0077, 39,0054, 39,0064, 39,0074, 39,0104, 39,0114, 39,0124, 39,0134, 39,0144, 39,0154, 39,0164, 39,0174, 39,0204, 39,0214, 0xFF}; // Model Name
const uint8_t  slc_8[] PROGMEM = {11,0077, 40,0022, 59,0113, 40,0025, 59,0116, 0xFF}; // Timers
const uint8_t  slc_9[] PROGMEM = {11,0077, 42,0163, 42,0166, 0xFF}; // Servo Speeds
const uint8_t slc_10[] PROGMEM = {11,0077, 43,0173, 43,0176, 0xFF}; // Trim Ranges
const uint8_t slc_11[] PROGMEM = {11,0077, 26,0003, 0xFF}; // Mixer Steering Source
const uint8_t slc_12[] PROGMEM = {11,0077, 44,0031, 44,0032, 44,0033, 44,0034, 44,0035, 44,0036, 0xFF}; // Channel Mixing
const uint8_t slc_13[] PROGMEM = {11,0077, 45,0051, 45,0052, 45,0053, 45,0054, 45,0055, 45,0056, 0xFF}; // Servo Reverse
const uint8_t slc_14[] PROGMEM = {11,0077, 46,0131, 46,0201, 46,0132, 46,0202, 46,0133, 46,0203, 46,0134, 46,0204, 46,0135, 46,0205, 46,0136, 46,0206, 0xFF}; // End Points
const uint8_t slc_15[] PROGMEM = {11,0077, 46,0071, 46,0072, 46,0073, 46,0074, 46,0075, 46,0076, 0xFF}; // Sub Trim
const uint8_t slc_16[] PROGMEM = {11,0077, 42,0174, 42,0175, 0xFF}; // Telemetry
const uint8_t slc_17[] PROGMEM = {6,0147, 42,0174, 42,0175, 0xFF}; // Transmitter Settings

const uint8_t* const choices[] PROGMEM = {
   slc_0,  slc_1,  slc_2,  slc_3,  slc_4,  slc_5,  slc_6,  slc_7,  slc_8,  slc_9,
  slc_10, slc_11, slc_12, slc_13, slc_14, slc_15, slc_16, slc_17
};

class screens {
  public:
    static void fTxt(uint8_t index, uint8_t posn, uint8_t rvsField); // draw text from flash memory table at specified position
    static void fixedText(uint8_t index); // clear screen and draw fixed text strings specified by index to fixed[] array
    // displays choices from list highlighting and returning [index] item. Uses encoder to modify selected index.  Draws items from list only when list changes - subsequently highlights using display buffer. *clicked is true when encoder pressed
    static uint8_t choice(uint8_t list, uint8_t item, bool *clicked);
    static void ChLabel(uint8_t column); // Draw a column of 6 ChX: labels at specified column
    static void displayChannels(uint8_t mode); // display channels mode 0 = percentages, mode 1 = microseconds
    static void displayCurrentModelName(uint8_t row, uint8_t column);
    static void prepareBargraphs(void); // set up 21 soft chars (2-22) ready for creating horizontal bargraphs
    static void positiveDecimal(uint16_t value, uint8_t len, uint8_t decPlaces, uint8_t row, uint8_t col, uint8_t rvsField);
    static void signedDecimal(int16_t value, uint8_t len, uint8_t decPlaces, uint8_t row, uint8_t col, uint8_t rvsField);
    static void hex(uint32_t value, uint8_t len, uint8_t row, uint8_t col, uint8_t rvsField);
  private:
    static int16_t old_us[];
    static uint8_t buff[];
    static uint8_t oldList;
    static uint8_t oldItem;
    static uint8_t listLength;
    static uint8_t choiceMode; // keeps track of what sort of choice is being made - fixed position menu, scrollable menu, etc. 
    static uint8_t *ftxt(uint8_t index, uint8_t *q); // helper function for drawing text from flash memory table - allows included strings
    static void bargraph(int8_t value, int8_t row); // draw a horizontal bargraph with value range -28 to +28 (centre zero) at specified row occupying columns 11-20
    static uint8_t fTxtLen(uint8_t index); // strlen of flashString{index];
    static void redrawScrolling1menu(uint8_t *p, uint8_t selected);
    static void redrawScrollType2(uint8_t selected);
    static void redrawScrollType3(uint8_t selected);
    static void decimal(uint8_t *buff, uint16_t value, uint8_t len, uint8_t decPlaces);
    static void displayModelName(uint8_t modelNum, uint8_t row, uint8_t column, uint8_t rvsField);
};
#endif
