#ifndef telemetry_h
#define telemetry_h

#include <Arduino.h>

class telemetry {
  public:
    static uint8_t rssi; // recceived signal strength indication 100+ is full signal.  40 is no signal.
    static uint8_t a1; // A1 (usually receiver voltage scaled 255 = 4 * 3.3V)
    static uint8_t a2; // A2 (usually power battery voltage; scaling depends on external resistor divider)
    static void start(void); 
    static void check(uint16_t mS); // mS is milliseconds since previous check

    static void handleRxChar(uint8_t b); // only declared public as it is called by the (non class member) interrupt service routine
  private:
    static void handlePacket(uint8_t *packet);
    static int16_t timeout; // used to detect loss of telemetry
};
#endif
