#include "timer1callback.h"

callbackPtr timer1callback::cbPtr;

void timer1callback::callMethodInMicros(callbackPtr callback, uint32_t t) {
  cbPtr = callback;
  TCCR1A = 0x00;
  uint8_t tccr1b;
  
  t <<= 4; // change from microseconds to clock cycles (16 MHz clock)
  if (t < 0x10000UL) tccr1b = 0x01; // no prescale, full xtal
  else if((t >>= 3) < 0x10000UL) tccr1b = 0x02; // prescale by /8
  else if((t >>= 3) < 0x10000UL) tccr1b = 0x03; // prescale by /64
  else if((t >>= 2) < 0x10000UL) tccr1b = 0x04; // prescale by /256
  else if((t >>= 2) < 0x10000UL) tccr1b = 0x05; // prescale by /1024
  else            t = 0x10000UL - 1, tccr1b = 0x05; // request was out of bounds, set as maximum

  TCNT1 = ~t; // no need for atomic interrupt-safe code as timer should always be stopped at this point
  TIMSK1 = 0x01; // enable timer interrupt
  TCCR1B = tccr1b; // start timer/counter 1
}

ISR(TIMER1_OVF_vect) {
  TIMSK1 = 0; // prevent further interrupts from timer/counter 1 till reenabled
  TCCR1B = 0x00; // stop timer/counter 1
  sei(); // allow interrupts
  timer1callback::cbPtr(); // callback
}


