#ifndef timers_h
#define timers_h

#include "config.h"

class timers {
  public:
    static void initialize(void);
    static void loop(uint16_t ms);
    static void startStop(uint8_t instance);
    static void reset(uint8_t instance);
    static void show(uint8_t instance, uint8_t row, uint8_t column, uint8_t rvsField);
    static void showType(uint8_t instance, uint8_t posn, uint8_t rvsField);
    static void showDuration(uint8_t instance, uint8_t row, uint8_t column, uint8_t rvsField);
  private:
    static uint8_t timerType[2];
    static int16_t timerSeconds[2];
    static bool timerRunning[2];
    static bool changed[2];
    static int16_t duration[2];
    static uint16_t milliseconds;
#ifdef A7_TIMER_BUTTON
    static uint16_t A7time;
#endif
    static void timerSecond(uint8_t instance);
    static void checkBeeper(int16_t seconds);
    static void displaySeconds(int16_t seconds, uint8_t row, uint8_t column, uint8_t rvsField);
};

#endif
